/**
 * Copyright (C) 2003-2005 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package sync4j.syncclient.demo;

import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Checkbox;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.ScrollPane;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.Color;

import sync4j.foundation.pdi.event.Calendar;


/**
 * A form containing all the fields concerning a calendar.
 * This form will be a subpanel for CalendarModify and CalendarNew
 *
 * @version $Id: CalendarForm.java,v 1.13 2005/09/30 13:55:07 nichele Exp $
 */
public class CalendarForm extends Panel
implements ActionListener, MouseListener, ItemListener, ConfigurationParameters {
    //---------------------------------------------------------- Constants

    //
    // Note this is NOT the actual size of the TextField.
    // It's just a way to avoid horizontal scrolling
    //
    public static final int TF_COLUMNS = 10;

    //---------------------------------------------------------- Private data

    //
    // The window containing this panel
    //
    private MainWindow mw = null;

    private Language ln = new Language();

    private TextField tf1 = null;
    private TextField tf2 = null;
    private TextField tf3 = null;
    private TextField tf4 = null;
    private TextField tf5 = null;
    private TextField tf6 = null;
    private TextField tf7 = null;

    private Checkbox   checkAllDayEvent  = null;

    private CardLayout cardLayout        = null;
    private Panel      fieldPanel        = null;
    private ScrollPane scrollGeneralPane = null;

    private Calendar   calendar          = null;

    //---------------------------------------------------------- Public methods
    public String getStartDate() {
        return tf2.getText();
    }
    public String getStartTime() {
        return tf6.getText();
    }
    public String getEndDate() {
        return tf3.getText();
    }
    public String getEndTime() {
        return tf7.getText();
    }
    public void setEndDate(String date) {
        tf3.setText(date);
    }
    public boolean isAllDayEvent() {
        return checkAllDayEvent.getState();
    }


    /**
     * Creates the form subpanel.
     *
     * @param mw the window containing this panel
     */
    public CalendarForm(MainWindow mw) {

        this.mw = mw;

        Panel generalPanel = new Panel();
        generalPanel.setLayout(new GridLayout(17, 2));

        //
        // Subject
        //
        Label lb1 = new Label(ln.getString("summary"   ));
        Label lb2 = new Label(ln.getString("start_date"));
        Label lb3 = new Label(ln.getString("end_date"  ));
        Label lb4 = new Label(ln.getString("location"  ));

        //
        // body
        //
        Label lb5 = new Label(ln.getString("description"));
        Label lb6 = new Label(ln.getString("start_time" ));
        Label lb7 = new Label(ln.getString("end_time"   ));

        Label lb8 = new Label(ln.getString("all_day_event"));

        tf1 = new TextField(TF_COLUMNS);
        tf2 = new TextField(TF_COLUMNS);
        tf3 = new TextField(TF_COLUMNS);
        tf4 = new TextField(TF_COLUMNS);
        tf5 = new TextField(TF_COLUMNS);
        tf6 = new TextField(TF_COLUMNS);
        tf7 = new TextField(TF_COLUMNS);

        checkAllDayEvent = new Checkbox(null);
        checkAllDayEvent.addItemListener(this);

        tf1.addMouseListener(this);
        tf2.addMouseListener(this);
        tf3.addMouseListener(this);
        tf4.addMouseListener(this);
        tf5.addMouseListener(this);
        tf6.addMouseListener(this);
        tf7.addMouseListener(this);


        generalPanel.add(lb1        );
        generalPanel.add(tf1        );
        generalPanel.add(lb2        );
        generalPanel.add(tf2        );
        generalPanel.add(lb6        );
        generalPanel.add(tf6        );
        generalPanel.add(lb3        );
        generalPanel.add(tf3        );
        generalPanel.add(lb7        );
        generalPanel.add(tf7        );
        generalPanel.add(lb8        );
        generalPanel.add(checkAllDayEvent);
        generalPanel.add(lb4        );
        generalPanel.add(tf4        );
        generalPanel.add(lb5        );
        generalPanel.add(tf5        );

        generalPanel.add(new Label());
        generalPanel.add(new Label());
        generalPanel.add(new Label());
        generalPanel.add(new Label());
        generalPanel.add(new Label());
        generalPanel.add(new Label());
        generalPanel.add(new Label());
        generalPanel.add(new Label());
        generalPanel.add(new Label());
        generalPanel.add(new Label());
        generalPanel.add(new Label());
        generalPanel.add(new Label());
        generalPanel.add(new Label());
        generalPanel.add(new Label());
        generalPanel.add(new Label());
        generalPanel.add(new Label());
        generalPanel.add(new Label());
        generalPanel.add(new Label());

        scrollGeneralPane = new ScrollPane(ScrollPane.SCROLLBARS_AS_NEEDED);
        scrollGeneralPane.add(generalPanel);

        fieldPanel = new Panel();
        fieldPanel.setSize(100,100);
        cardLayout = new CardLayout();
        fieldPanel.setLayout(cardLayout);
        fieldPanel.add(scrollGeneralPane,"general");

        //
        // Default
        //
        cardLayout.show(fieldPanel, "general");

        setLayout(new BorderLayout());
        add(fieldPanel,BorderLayout.CENTER);
    }

    public void actionPerformed(ActionEvent evt) {
        //do nothing
    }

    /**
     * Invoked when the mouse button has been clicked (pressed and released)
     * on a component.
     * This method adjusts the scrollpanes so that the selected
     * textfield is placed on top of the pane.
     *
     * @param evt the occurred event
     */
    public void mouseClicked(MouseEvent evt) {
        //do nothing
    }

    /**
     * Invoked when a mouse button has been pressed on a component.
     * Not used.
     *
     * @param evt the occurred event
     */
    public void mousePressed(MouseEvent evt) {
        // do nothing
    }

    /**
     * Invoked when a mouse button has been released on a component.
     * Not used.
     *
     * @param evt the occurred event
     */
    public void mouseReleased(MouseEvent evt) {
        // do nothing
    }

    /**
     * Invoked when the mouse enters a component.
     * Not used.
     *
     * @param evt the occurred event
     */
    public void mouseEntered(MouseEvent evt) {
        // do nothing
    }

    /**
     * Invoked when the mouse exits a component.
     * Not used.
     *
     * @param evt the occurred event
     */
    public void mouseExited(MouseEvent evt) {
        // do nothing
    }

    /**
     * Invoked when the checkAllDayEvent changes his state.
     *
     * @param evt the occurred event
     */
    public void itemStateChanged(ItemEvent evt) {
        if (evt.getStateChange() == ItemEvent.DESELECTED) {
            setAsAllDayEvent(false);
        } else if (evt.getStateChange() == ItemEvent.SELECTED) {
            setAsAllDayEvent(true);
        }

    }
    //---------------------------------------------------------- Protected methods

    /**
     * Sets the fields with the values contained
     * in the specified Calendar object.
     * Used to display the old value of calendar
     *
     * @param calendar the Calendar object which is the source of the values
     */
    protected void setFields(Calendar calendar) {

        this.calendar = calendar;

        String dateStart = null;
        String dateEnd   = null;
        String timeStart = null;
        String timeEnd   = null;

        dateStart = (String)calendar.getEvent().getDtStart().getPropertyValue();
        dateEnd   = (String)calendar.getEvent().getDtEnd().getPropertyValue()  ;

        if (!calendar.getEvent().isAllDay()) {

            dateStart = FieldsHelper.convertDateFromUTC(dateStart);
            if (dateStart != null && dateStart.length() > 10) {
                timeStart = dateStart.substring(11,16);
                dateStart = dateStart.substring(0,10);
            }

            dateEnd = FieldsHelper.convertDateFromUTC(dateEnd);
            if (dateEnd != null &&   dateEnd.length() > 10) {
                timeEnd = dateEnd.substring(11,16);
                dateEnd = dateEnd.substring(0,10);
            }

            tf6.setText(timeStart != null ? timeStart : "");
            tf6.setEnabled(true);
            tf6.setBackground(java.awt.SystemColor.window);
            tf7.setText(timeEnd   != null ? timeEnd   : "");
            tf7.setEnabled(true);
            tf7.setBackground(java.awt.SystemColor.window);

            checkAllDayEvent.setState(false);

        } else {
            tf6.setText("");
            tf6.setEnabled(false);
            tf6.setBackground(new Color(230, 230, 230));
            tf7.setText("");
            tf7.setEnabled(false);
            tf7.setBackground(new Color(230, 230, 230));

            dateStart = FieldsHelper.convertInDayFormatFrom(dateStart);
            dateEnd   = FieldsHelper.convertInDayFormatFrom(dateEnd)  ;

            checkAllDayEvent.setState(true);
        }

        // General
        tf1.setText((String)calendar.getEvent()
                                    .getSummary().getPropertyValue());
        tf2.setText(dateStart);
        tf3.setText(dateEnd  );
        tf4.setText((String)calendar.getEvent()
                                    .getLocation().getPropertyValue());
        tf5.setText((String)calendar.getEvent()
                                    .getDescription().getPropertyValue());
    }

    /**
     * Returns a new Calendar object containing the informations set in the textfields.
     * This method also builds the LABELs from the provided addresses, when at least
     * street, city, state, postal code and country are specified.
     *
     * @return the Calendar object containing the informations set in the textfields
     */
    protected Calendar getFields(){

        Calendar calendar = new Calendar();
        this.calendar = calendar;

        String startDate = tf2.getText();
        String endDate   = tf3.getText();

        if (!checkAllDayEvent.getState()) {
            String fullStartDate = tf2.getText() + " " + tf6.getText() + ":00";
            String fullEndDate   = tf3.getText() + " " + tf7.getText() + ":00";
            startDate = FieldsHelper.convertDateToUTC(fullStartDate);
            endDate   = FieldsHelper.convertDateToUTC(fullEndDate  );
            calendar.getEvent().setAllDay(Boolean.FALSE);
        } else {
            startDate = FieldsHelper.convertInDayFormatTo(startDate);
            endDate   = FieldsHelper.convertInDayFormatTo(endDate  );
            calendar.getEvent().setAllDay(Boolean.TRUE);
        }

        calendar.getEvent().getSummary    ().setPropertyValue(tf1.getText());
        calendar.getEvent().getDtStart    ().setPropertyValue(startDate    );
        calendar.getEvent().getDtEnd      ().setPropertyValue(endDate      );
        calendar.getEvent().getLocation   ().setPropertyValue(tf4.getText());
        calendar.getEvent().getDescription().setPropertyValue(tf5.getText());

        return calendar;
    }

    protected void setAsAllDayEvent(boolean isAllDayEvent) {

        String dateStart = null;
        String dateEnd   = null;
        String timeStart = null;
        String timeEnd   = null;

        dateStart = (String)calendar.getEvent().getDtStart().getPropertyValue();
        dateEnd   = (String)calendar.getEvent().getDtEnd().getPropertyValue()  ;

        if (isAllDayEvent) {

            tf6.setText("");
            tf6.setEnabled(false);
            tf6.setBackground(new Color(230, 230, 230));
            tf7.setText("");
            tf7.setEnabled(false);
            tf7.setBackground(new Color(230, 230, 230));

            dateStart = FieldsHelper.convertInDayFormatFrom(dateStart);
            dateEnd   = FieldsHelper.convertInDayFormatFrom(dateEnd)  ;

            checkAllDayEvent.setState(true);

        } else {

            dateStart = FieldsHelper.convertDateFromUTC(dateStart);
            if (dateStart != null && dateStart.length() > 10) {
                timeStart = dateStart.substring(11,16);
                dateStart = dateStart.substring(0,10);
            }

            dateEnd = FieldsHelper.convertDateFromUTC(dateEnd);
            if (dateEnd != null &&   dateEnd.length() > 10) {
                timeEnd = dateEnd.substring(11,16);
                dateEnd = dateEnd.substring(0,10);
            }

            tf6.setText(timeStart != null ? timeStart : "");
            tf6.setEnabled(true);
            tf6.setBackground(java.awt.SystemColor.window);
            tf7.setText(timeEnd   != null ? timeEnd   : "");
            tf7.setEnabled(true);
            tf7.setBackground(java.awt.SystemColor.window);

            checkAllDayEvent.setState(false);
        }
    }

    /**
     * Sets all the textfields to an empty string.
     */
    protected void blankFields() {
        tf1.setText("");
        tf2.setText("");
        tf3.setText("");
        tf4.setText("");
        tf5.setText("");
        tf6.setText("");
        tf7.setText("");
    }
}
